require_relative './abstract_page'
require_relative './finish_task_page'

class AssignPage < AbstractPage

    def initialize(driver)
        super(driver)
    end

    def findAssignedElements(wait)
        wait.until { @@driver.find_element(:class => "fjimLu") }
        array = @@driver.find_elements(class: "fjimLu")
        return array
    end

    def assignName(wait)
        elements = findAssignedElements(wait)
        elements[0].click
        wait.until { @@driver.find_element(:class => "fAHbVa") }
        @@driver.find_element(class: "fAHbVa").click
        wait.until { @@driver.find_element(:class => "cXKOsV") }
        @@driver.find_element(class: "cXKOsV").click
        @@driver.action.move_to_location(500, 350).perform
        @@driver.action.click.perform
        return AssignPage.new(@@driver)
    end

    def assignTime(wait)
        elements = findAssignedElements(wait)
        elements[1].click
        wait.until { @@driver.find_element(:class => "sc-iFUGim") }
        @@driver.find_element(class: "sc-iFUGim").click
        wait.until { @@driver.find_element(:class => "cXKOsV") }
        @@driver.find_element(class: "cXKOsV").click
        @@driver.action.move_to_location(500, 275).perform
        @@driver.action.click.perform
        return AssignPage.new(@@driver)
    end

    def assignText(wait)
        elements = findAssignedElements(wait)
        elements[2].click
        wait.until { @@driver.find_element(:class => "kObcii") }
        @@driver.find_element(class: "kObcii").send_keys("Text 測試文字")
        wait.until { @@driver.find_element(:class => "cXKOsV") }
        @@driver.find_element(class: "cXKOsV").click
        @@driver.action.move_to_location(500, 200).perform
        @@driver.action.click.perform
        return AssignPage.new(@@driver)
    end

    def assignCheckbox(wait)
        elements = findAssignedElements(wait)
        elements[3].click
        @@driver.action.move_to_location(700, 275).perform
        @@driver.action.click.perform
        return AssignPage.new(@@driver)
    end

    def assignRadioBtn(wait)
        elements = findAssignedElements(wait)
        elements[4].click
        @@driver.action.move_to_location(700, 350).perform
        @@driver.action.click.perform
        return AssignPage.new(@@driver)
    end

    def clickNextStep
        @@driver.find_element(class: "fSImrr").click
        return AssignPage.new(@@driver)
    end

    def comfirmCreateDocument(wait)
        wait.until { @@driver.find_element(:id => "Edit-Field-Send-SignYourself") }
        @@driver.find_element(id: "Edit-Field-Send-SignYourself").click
        return FinishTaskPage.new(@@driver)
    end
end
