require_relative './abstract_page'
require_relative './upload_page'
require_relative './finish_task_page'

class MainPage < AbstractPage

    def initialize(driver)
        super(driver)
    end

    def clickPurpleCircle(wait)
        wait.until {@@driver.find_element(class: "sc-fkyLDJ").displayed?}
        @@driver.find_element(class: "sc-fkyLDJ").click
        return MainPage.new(@@driver)
    end

    def clickSignYourself(wait)
        wait.until {@@driver.find_element(id: "Task-AddTask-SignYourself").displayed?}
        @@driver.find_element(id: "Task-AddTask-SignYourself").click
        return UploadPage.new(@@driver)
    end

    def clickCompletedPage(wait)        
        wait.until { @@driver.find_element(:class => "jcZYPF") }
        tabs = @@driver.find_elements(class: "jcZYPF")
        tabs[2].click
        return MainPage.new(@@driver)
    end

    def clickNewestDocument(wait)
        wait.until { @@driver.find_element(:class => "bxKayE") }
        @@driver.find_element(class: "bxKayE").click
        sleep 15
        return FinishTaskPage.new(@@driver)
    end

    # GetSignature starts from here
    def clickGetSignature(wait)
        wait.until {@@driver.find_element(id: "Task-AddTask-GetSignatures").displayed?}
        @@driver.find_element(id: "Task-AddTask-GetSignatures").click
        return UploadPage.new(@@driver)
    end


end