require_relative './abstract_page'
require_relative './main_page'

class LoginPage < AbstractPage

    def initialize(driver)
        super(driver)
    end

    def fillInEmail(email)
        @@driver.find_element(id: "member_email").send_keys(email)
        return LoginPage.new(@@driver)
    end

    def clickBtnAfterFillingEmail
        @@driver.find_element(class: "login100-form-btn").click
        return LoginPage.new(@@driver)
    end

    def fillInPassword(password,wait)
        wait.until {@@driver.find_element(id:'member_password').displayed?}
        @@driver.find_element(id: "member_password").send_keys(password)
        return LoginPage.new(@@driver)
    end

    def clickBtnAfterFillingPassword
        @@driver.find_element(id: "btn-ready-send").click
        return MainPage.new(@@driver)
    end
end